<?php

/**
 * News Manager edit settings template
 */

?>

<h3><?php i18n("news_manager/NM_SETTINGS"); ?></h3>
<p class="hint">
  <?php i18n("news_manager/DOCUMENTATION"); ?>
</p>
<form class="largeform" action="load.php?id=news_manager" method="post" accept-charset="utf-8">
  <div class="leftsec">
    <p>
      <label for="page_url"><?php i18n("news_manager/PAGE_URL"); ?>:</label>
      <select class="text" name="page_url">
      <?php
      $pages = get_available_pages();
      foreach ($pages as $page) {
        $slug = $page['slug'];
        if ($slug == $NMPAGEURL)
          echo "<option value=\"$slug\" selected=\"selected\">$slug</option>\n";
        else
          echo "<option value=\"$slug\">$slug</option>\n";
      }
      ?>
      </select>
    </p>
  </div>
  <div class="rightsec">
    <p>
      <label for="excerpt_length"><?php i18n("news_manager/EXCERPT_LENGTH"); ?>:</label>
      <input class="text" type="text" name="excerpt_length" value="<?php echo $NMEXCERPTLENGTH; ?>" />
    </p>
  </div>
  <div class="clear"></div>
  <div class="leftsec">
    <p>
      <label for="show_excerpt"><?php i18n("news_manager/SHOW_POSTS_AS"); ?>:</label>
      <input name="show_excerpt" type="radio" value="0" <?php if ($NMSHOWEXCERPT != 'Y') echo "checked=\"checked\""; ?> style="vertical-align: middle;" />
      &nbsp;<?php i18n("news_manager/FULL_TEXT"); ?>
      <span style="margin-left: 30px;">&nbsp;</span>
      <input name="show_excerpt" type="radio" value="1" <?php if ($NMSHOWEXCERPT == 'Y') echo "checked=\"checked\""; ?> style="vertical-align: middle;" />
      &nbsp;<?php i18n("news_manager/EXCERPT"); ?>
    </p>
  </div>
  <div class="rightsec">
    <p>
      <label for="posts_per_page"><?php i18n("news_manager/POSTS_PER_PAGE"); ?>:</label>
      <input class="text" type="text" name="posts_per_page" value="<?php echo $NMPOSTSPERPAGE; ?>" />
    </p>
  </div>
  <div class="clear"></div>
  <div class="leftsec"></div>
  <div class="rightsec">
    <p>
      <label for="recent_posts"><?php i18n("news_manager/RECENT_POSTS"); ?>:</label>
      <input class="text" type="text" name="recent_posts" value="<?php echo $NMRECENTPOSTS; ?>" />
    </p>
  </div>
  <div class="clear"></div>
  <p id="submit_line">
    <span>
      <input class="submit" type="submit" name="settings" value="<?php i18n("news_manager/SAVE_SETTINGS"); ?>" />
    </span>
    &nbsp;&nbsp;<?php i18n('news_manager/OR'); ?>&nbsp;&nbsp;
    <a href="load.php?id=news_manager" class="cancel"><?php i18n("news_manager/CANCEL"); ?></a>
  </p>
</form>
