<?php

/**
 * News Manager english language file
 */


$i18n = array(

# general
"PLUGIN_NAME"         =>  "News Manager",

# error messages
"ERROR_ENV"           =>  "There was an error accessing the posts folder and/or config file. <em>CHMOD 777</em> the folder /data and its sub-folders and retry.",
"ERROR_SAVE_CONFIG"   =>  "<b>Error:</b> Unable to write config file. <em>CHMOD 777</em> the folder /data and its sub-folders and retry.",
"ERROR_EMPTY_POST"    =>  "<b>Error:</b> You cannot save a post without a title.",
"ERROR_SAVE_POST"     =>  "<b>Error:</b> Unable to save the post. <em>CHMOD 777</em> the folder /data/posts and retry.",
"ERROR_DELETE_POST"   =>  "<b>Error:</b> Unable to delete the post. <em>CHMOD 777</em> the folder /data/posts and retry.",

# success messages
"SUCCESS_SAVE_CONFIG" =>  "Your settings have been updated.",
"SUCCESS_SAVE_POST"   =>  "Your changes have been saved.",
"SUCCESS_DELETE_POST" =>  "The post has been deleted.",

# admin button (top-right)
"SETTINGS"            =>  "Settings",
"NEW_POST"            =>  "Create New Post",

# admin panel
"POST_TITLE"          =>  "Post Title",
"DATE"                =>  "Date",
"EDIT_POST"           =>  "Edit Post",
"VIEW_POST"           =>  "View Post",
"DELETE_POST"         =>  "Delete Post",
"POSTS"               =>  "posts",

# edit settings
"NM_SETTINGS"         =>  "News Manager Settings",
"DOCUMENTATION"       =>  "For more information on these settings, visit the <a href=\"http://rxgr.nl/getsimple/\" target=\"_blank\">documentation page</a>.",
"PAGE_URL"            =>  "Page To Display Posts",
"SHOW_POSTS_AS"       =>  "Posts On News Page Are Shown As",
"EXCERPT_LENGTH"      =>  "Excerpt Length (Characters)",
"POSTS_PER_PAGE"      =>  "Number Of Posts On News Page",
"RECENT_POSTS"        =>  "Number Of Recent Posts (In Sidebar)",
"FULL_TEXT"           =>  "Full Text",
"EXCERPT"             =>  "Excerpt",

# edit post
"POST_OPTIONS"        =>  "Post Options",
"POST_TAGS"           =>  "Tags (separate tags with commas)",
"POST_PRIVATE"        =>  "Post Is Private",
"LAST_SAVED"          =>  "Last Saved",

# save/cancel/delete
"SAVE_SETTINGS"       =>  "Save Settings",
"SAVE_POST"           =>  "Save Post",
"CANCEL"              =>  "Cancel",
"DELETE"              =>  "Delete",
"OR"                  =>  "or",

# front-end/site
"FOUND"               =>  "The following posts have been found:",
"NOT_FOUND"           =>  "Sorry, your search returned no hits.",
"NOT_EXIST"           =>  "The requested post does not exist.",
"NO_POSTS"            =>  "No posts have been published yet.",
"PUBLISHED"           =>  "Published on",
"TAGS"                =>  "Tags",
"OLDER_POSTS"         =>  "Older Posts",
"NEWER_POSTS"         =>  "Newer Posts",
"SEARCH"              =>  "Search"

);

?>
