<?php

/**
 * News Manager dutch language file
 */


$i18n = array(

# general
"PLUGIN_NAME"         =>  "News Manager",

# error messages
"ERROR_ENV"           =>  "Er zijn fouten opgetreden bij het schrijven naar de berichten map en/of het configuratie bestand. <em>CHMOD 777</em> de map /data en de onderliggende bestanden en probeer opnieuw.",
"ERROR_SAVE_CONFIG"   =>  "<b>Fout:</b> Kan het configuratie bestand niet opslaan. <em>CHMOD 777</em> de map /data en de onderliggende bestanden en probeer opnieuw.",
"ERROR_EMPTY_POST"    =>  "<b>Fout:</b> Je kunt geen bericht zonder titel opslaan.",
"ERROR_SAVE_POST"     =>  "<b>Fout:</b> Kan het bericht niet opslaan. <em>CHMOD 777</em> de map /data/posts en probeer opnieuw.",
"ERROR_DELETE_POST"   =>  "<b>Fout:</b> Kan het bericht niet verwijderen. <em>CHMOD 777</em> de map /data/posts en probeer opnieuw.",

# success messages
"SUCCESS_SAVE_CONFIG" =>  "De instellingen zijn opgeslagen.",
"SUCCESS_SAVE_POST"   =>  "De wijzigingen zijn opgeslagen.",
"SUCCESS_DELETE_POST" =>  "Het bericht is verwijderd.",

# admin button (top-right)
"SETTINGS"            =>  "Instellingen",
"NEW_POST"            =>  "Nieuw Bericht",

# admin panel
"POST_TITLE"          =>  "Titel",
"DATE"                =>  "Datum",
"EDIT_POST"           =>  "Bewerk Bericht",
"VIEW_POST"           =>  "Bekijk Bericht",
"DELETE_POST"         =>  "Verwijder Bericht",
"POSTS"               =>  "berichten",

# edit settings
"NM_SETTINGS"         =>  "News Manager Instellingen",
"DOCUMENTATION"       =>  "Voor meer informatie over deze instellingen, bezoek de <a href=\"http://rxgr.nl/getsimple/\" target=\"_blank\">documentatie pagina</a>.",
"PAGE_URL"            =>  "Berichtenpagina",
"SHOW_POSTS_AS"       =>  "Berichten Weergegeven Als",
"EXCERPT_LENGTH"      =>  "Lengte Van Een Samenvatting (Karakters)",
"POSTS_PER_PAGE"      =>  "Aantal Berichten Op De Nieuwspagina",
"RECENT_POSTS"        =>  "Aantal Recente Berichten (Sidebar)",
"FULL_TEXT"           =>  "Volledige Tekst",
"EXCERPT"             =>  "Samenvatting",

# edit post
"POST_OPTIONS"        =>  "Bericht Opties",
"POST_TAGS"           =>  "Tags (meerdere tags scheiden met komma's)",
"POST_PRIVATE"        =>  "Bericht Is Priv&#233;",
"LAST_SAVED"          =>  "Laatst Bijgewerkt",

# save/cancel/delete
"SAVE_SETTINGS"       =>  "Instellingen Opslaan",
"SAVE_POST"           =>  "Wijzigingen Opslaan",
"CANCEL"              =>  "Annuleren",
"DELETE"              =>  "Verwijderen",
"OR"                  =>  "of",

# front-end/site
"FOUND"               =>  "De volgende berichten zijn gevonden:",
"NOT_FOUND"           =>  "Helaas, er zijn geen berichten gevonden.",
"NOT_EXIST"           =>  "Het opgevraagde bericht bestaat niet.",
"NO_POSTS"            =>  "Er zijn nog geen berichten geplaatst.",
"PUBLISHED"           =>  "Gepubliceerd op",
"TAGS"                =>  "Tags",
"OLDER_POSTS"         =>  "Oudere Berichten",
"NEWER_POSTS"         =>  "Nieuwere Berichten",
"SEARCH"              =>  "Zoek"

);

?>
