<?php

/**
 * News Manager edit post template
 */

?>

<h3 class="floated">
  <?php
  if (empty($data))
    i18n("news_manager/NEW_POST");
  else
    i18n("news_manager/EDIT_POST");
  ?>
</h3>
<div class="edit-nav" >
  <?php
  if (file_exists($file) && $private == '') {
    $url = nm_get_url('post') . $id;
    ?>
    <a href="<?php echo $url; ?>" target="_blank">
      <?php i18n("news_manager/VIEW_POST"); ?>
    </a>
    <?php
  }
  ?>
  <a href="#" id="metadata_toggle">
    <?php i18n("news_manager/POST_OPTIONS"); ?>
  </a>
  <div class="clear"></div>
</div>
<form class="largeform" action="load.php?id=news_manager" method="post" accept-charset="utf-8">
  <p>
    <input name="post-id" type="hidden" value="<?php echo $id; ?>" />
  </p>
  <p>
    <input class="text title" name="post-title" type="text" value="<?php echo $title; ?>" />
  </p>
  <div style="display:none;" id="metadata_window">
    <div class="leftopt">
      <p>
        <label for="post-tags"><?php i18n("news_manager/POST_TAGS"); ?>:</label>
        <input class="text short" id="post-tags" name="post-tags" type="text" value="<?php echo $tags; ?>" />
      </p>
      <p class="inline" id="post-private-wrap">
        <label for="post-private"><?php i18n("news_manager/POST_PRIVATE"); ?></label>
        &nbsp;&nbsp;
        <input type="checkbox" id="post-private" name="post-private" <?php echo $private; ?> />
      </p>
    </div>
    <div class="rightopt"></div>
    <div class="clear"></div>
  </div>
  <p>
    <textarea name="post-content"><?php echo $content; ?></textarea>
  </p>
  <p>
    <input name="post" type="submit" class="submit" value="<?php i18n("news_manager/SAVE_POST"); ?>" />
    &nbsp;&nbsp;<?php i18n('news_manager/OR'); ?>&nbsp;&nbsp;
    <a href="load.php?id=news_manager" class="cancel"><?php i18n("news_manager/CANCEL"); ?></a>
    <?php
    if (file_exists($file)) {
      ?>
      /
      <a href="load.php?id=news_manager&delete=<?php echo $id; ?>" class="cancel">
        <?php i18n("news_manager/DELETE"); ?>
      </a>
      <?php
    }
    ?>
  </p>
</form>
